/* this programm needs ANSI-terminal
   Isingmodell mit NN-WW -> Monte Carlo
   ansi - andrere Farben ???
   
   v0.1.2 - -option -b for back-end, tcl/tk front-end
   v0.1.1 - initial version, only ASCII-output

   ToDo:
     - m^2=sum(sisj) berechnen
     - O(3) mit 3D-colors rgb
     - cluster MC
   
*/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#ifdef __MSDOS__
#include <conio.h>
#define Cls()    clrscr()                            /* clrscr */
#define Gxy(x,y) gotoxy(x,y)                         /* set cursor */
#define Col(f,b) textattr(16*b+f)                    /* color 0..7 */
#define Res()    textattr(7);              
#define Putch(c) putch(c)
#define Gets(c)  gets(c)
#define Cprintf  cprintf
#else
#define Cls()    printf("\033[2J")                   /*     clrscr */
#define Gxy(x,y) printf("\033[%d;%dH",y,x)           /* set cursor */
#define Col(f,b) printf("\033[%d;3%d;4%dm",f>>3,Rgb(f),Rgb(b))
#define Res()    printf("\033[0m");  
#define Rgb(c)   ((c&2)|(c<<2&4)|(c>>2&1))
#define Putch(c) putc(c,stdout)
#define Gets(c)  fgets(c,10,stdin)
#define Cprintf  printf
#endif
typedef double zahl;
#define Nx 100
#define Ny 100
#define Nn (Nx*Ny)

#define version_string "0.1.2 10/03/1999"

int s[Nn],s2[Nn],w[2*Nn],
    nx,ny,nn,
    sz,smin,smax;
zahl temp,feld,e,emin,emax,szm;

int mode=0;  /* 0=ANSI-output, 1=tcl/tk-backend */

int hex8(r)zahl r;
{ unsigned char *s2;int i; s2=(unsigned char *)&(r);
  for(i=0;i<sizeof(zahl);i++) { printf("%02x",(int)s2[i]); } return(0);
}

zahl energy(){
  int i,j;zahl ee;ee=0.0;
  for(i=0;i<nx;i++)for(j=0;j<ny;j++)
   ee+=w[2*(j*nx+i)+0]*s[j*nx+i]*s[j*nx+((i+1)%nx)]
      +w[2*(j*nx+i)+1]*s[j*nx+i]*s[((j+1)%ny)*nx+i];
  if(feld!=0.0)for(i=0;i<nn;i++)ee+=feld*s[i];
  return(ee);
}

void outt(){if(!mode)Gxy(55, 7);printf("k*T =%13.3f\n",temp);}
void oute(int i){
  double n1=1./nn;
  if(!mode){ Gxy(55, 8);printf("E   = % 12.8f\n",e*n1);
             Gxy(55, 9);printf("Eext= % 8f/% 8f\n",emin*n1,emax*n1);
             Gxy(55,10);printf("S/M = % 8f/% 8f\n",sz*n1,szm);
             Gxy(55,11);printf("Sext= % 8f/% 8f\n",smin*n1,smax*n1);
  } else {
     printf("E%c % 6f % 6f % 6f ",((i)?' ':'='),e/nn,emin/nn,emax/nn);
     printf("S= % 6f % 6f % 6f % 6f\n",sz*n1,szm,smin*n1,smax*n1);
     fflush(stdout);
  }
}

void printspin(int i){
  int x,y;x=i%nx;y=i/nx;
  if( mode ) return; /* ToDo: write to a mapped PPM-file */
  if((x>16)||(y>19))return;
  Gxy(3*x+1,y+2);
  if(s[i]<0){Col( 7,1);Cprintf(" x ");}else
  if(s[i]>0){Col( 7,4);Cprintf(" o ");}else{Col(7,0);Cprintf("   ");}
  Res();
}

/* update screen */
void printgitter(){
    int i,j,x,y; FILE *f1;
    if(mode){ /* ToDo: write a PGM file (name as option?) */
     f1=fopen("monte.pgm","r+");
     if(!f1)f1=fopen("monte.pgm","w");
#if 0
     fprintf(f1,"P5\n%d %d\n255\n",2*nx,2*ny);
     for(y=0;y<ny;y++){
       /* bond + status */
       for(x=0;x<nx;x++){ 
         i=w[2*(y*nx+x)+0]; /* x bond */
         j=s[y*nx+x];
         fputc((j+1)*127,f1); /* spin -1=0, 0=127, 1=254 */
         fputc((i+1)*127,f1); /* bond -1=0, 0=127, 1=254 */
       }
       for(x=0;x<nx;x++){
         i=w[2*(y*nx+x)+1]; /* y bond */
         fputc((i+1)*127,f1); /* bond -1=0, 0=127, 1=254 */
         fputc(      127,f1); /* gray */
       }
     }
#else
     fprintf(f1,"P5\n%d %d\n255\n",nx,ny);
     for(y=0;y<ny;y++)
     for(x=0;x<nx;x++){
       j=s[y*nx+x]; fputc((j+1)*127,f1); /* spin -1=0, 0=127, 1=254 */
     }
#endif
     fclose(f1);
     return;
    }
    for(x=0;(x<3)&&(x<nx);x++)
    for(y=0;(y<4)&&(y<ny);y++)
    {
        Gxy(55+6*x,14+2*y);i=y*nx+x;
        if(s[i]<0){Col( 1,2);Cprintf(" x ");}
              else{Col( 4,2);Cprintf(" o ");};
        Col(15,2);
        if(w[2*i+0]>0)Cprintf(" + ");else
        if(w[2*i+0]<0)Cprintf(" - ");else Cprintf("   ");
        Gxy(55+6*x,15+2*y);
        if(w[2*i+1]>0)Cprintf(" + ");else
        if(w[2*i+1]<0)Cprintf(" - ");else Cprintf("   ");
    }
    Res();
}

void printstate()
{ int i,j;sz=0;
  for(i=0;i<nn;i++){printspin(i);sz+=s[i];};
  if(!mode)Res();
  e=energy();
  if(!mode){
    Gxy(15, 1);printf(">>> Monte-Carlo-Methode fuer das Ising-Modell <<<");
    // Gxy(55, 3);printf("period. Randb. = %d",period);
    Gxy(55, 4);printf("Groesse    = %dx%d",nx,ny);
    Gxy(55, 6);printf("Feld     B =%6.3f",feld);
    Gxy(55, 5);printf("krit. Temp.= 2.269");
    Gxy(55,12);printf("?,h - hilfe");
  }
  outt();printgitter();oute(0);
}
/*
      if(zfallszahl(0..1)<=exp(-de[i]/temp)) flipspin(i);
      dE[i] = -2 Sum Jij*Si*Sj - 2 B Si
            = -2 Si (Sum Jij Sj + B)
   (Sum Jij Sj) und (Si) sind die Variablen mit (-4..4)*(-1..1) Mglkn. 
*/
void monte(n)long n;
{ int i,j,x,y,b,de,zz[9*2];long v,zm;
  if(temp!=0.0)
  for(i=0;i<=8;i++)for(j=0;j<2;j++) /* Sum Jij Sj = i-4, Si = j*2-1 */
  if(2.0*(j*2-1)*(i-4+feld)/temp>=0)zz[i*2+j]=RAND_MAX;
  else zz[i*2+j]=(int)(RAND_MAX*exp(2.0*(j*2-1)*(i-4+feld)/temp));
  smin=smax=sz;zm=0l;
  emin=emax=e;
  for(v=0l;v<n;v++)
  {
    if(v%nn==0l)zm+=(sz);
    i =rand()%nn;de=0;b=0;x=i%nx;y=i/nx;
    if((20*v)%n==0){
      if(!mode) { Gxy(3,23);printf("%4d%%",20*v/n);fflush(stdout); }
      else      { printgitter(); oute(1); }
    }

    if(x<nx-1)de+=w[2*i       ]*s[i   +1];
     else     de+=w[2*i       ]*s[i-nx+1];
    if(x>   0)de+=w[2*i     -2]*s[i   -1];
     else     de+=w[2*(i+nx)-2]*s[i+nx-1];
    if(y<ny-1)de+=w[2*i     +1]*s[i+nx];
     else     de+=w[2*i     +1]*s[   x];
    if(y>   0)de+=w[2*(i-nx)+1]*s[i-nx];
     else     de+=w[2*(nn-nx+x)+1]*s[nn-nx+x];

    if(-2.0*s[i]*((zahl)de+feld)<=0.0)b=1; else
    if(temp!=0.0)if(rand()<=zz[(de+4)*2+(s[i]+1)/2])b=1;
    if(b!=0)
    { 
      e-=2.0*s[i]*(de+feld);
      s[i]*=(-1);printspin(i);sz+=(2*s[i]);
      if(sz<smin)smin=sz;if(sz>smax)smax=sz;
      if( e<emin)emin=e; if( e>emax)emax=e; 
      if(!mode)Res();
      if(v%nn==0 && mode==0){ oute(0); };
    }
  }
  szm=(zm/(n/nn))/(zahl)nn; /* gemittelt ueber n/nn loops */
  if(!mode)Res();
  printgitter();oute(0);
}


int main(int argn, char *argv[]){
  char c[30],c2[30];int i,j;long l;
  for (i=1;i<argn;i++) {
    if (argv[i][0]=='-') {
      if (argv[i][1]=='b') { mode=1; }; /* use as tcl/tk backend */
    }
  }
  for(i=0;i<Nn;i++)s[i]=-1;
  for(i=0;i<2*Nn;i++)w[i]=0;
  temp=0.0;feld=0.0;nx=Nx;ny=Ny;nn=nx*ny;
  sz=smax=smin=-nn;szm=0.0;
  e=energy();emin=emax=e;
  if (mode==0) { Res();Cls(); }
  printstate();printgitter();
  c[0]=0;
  while(c[0]!='q')
  {
    /* generate a prompt */
    if(mode==0){ Gxy(1,23);printf(">                ");Gxy(2,23); }
    /* else       { printf(">\n"); fflush(stdout); } */
    /* read command */
    Gets(c);
    if(c[0]=='z')
    {  if(c[1]=='z')
        {for(i=0;i<Nn;i++)s[i]=2*(rand()%2)-1;printstate();continue;}
       else {sscanf(c,"%*c%d",&i);srand(i);};
    } else
    if(c[0]=='b')
    {
       if(c[1]=='f'){for(i=0;i<2*Nn;i++)w[i]=-1;}else
       if(c[1]=='a'){for(i=0;i<2*Nn;i++)w[i]= 1;}else
       if(c[1]=='z'){for(i=0;i<2*Nn;i++)w[i]=2*(rand()%2)-1;}else
       if(c[1]=='p')
       {
          for(i=0;i<2*nn;i++)w[i]=1;
          for(i=0;i<nn;i++)
          if((((i%nx)%2==0)&&((i/nx)%2==0))||
             (((i%nx)%2==1)&&((i/nx)%2==1)))w[2*i]=-1;
       } else
       if(c[1]=='4') for(i=0;i<2*nn;i++)
       {    
            if(c[(i%(2*nx))%4+4*((i/2/nx)%2)+2]=='+')w[i]=+1;else
            if(c[(i%(2*nx))%4+4*((i/2/nx)%2)+2]=='-')w[i]=-1;else w[i]=0;
       }
       printstate();continue;
    } else
    if(c[0]=='g')
    {
       sscanf(c,"%*c%d",&nx);ny=nx;nn=nx*ny;
       for(i=0;i<Nn;i++)s[i]=-1;
       for(i=0;i<2*Nn;i++)w[i]=0;
       if(!mode)Cls();
       printstate();continue;
    } else
    if(c[0]=='e'){sscanf(c,"%*c%ld",&l);monte(l);continue;} else
    if(c[0]=='m'){sscanf(c,"%*c%ld",&l);monte(l*nn);continue;} else
    if(c[0]=='t'){sscanf(c,"%*c%lf",&temp);outt();continue;} else
    if(c[0]=='f'){sscanf(c,"%*c%lf",&feld);printstate();continue;} else
    if(c[0]=='p'){
       /* set OBC */
       for(i=0;i<nx;i++)for(j=0;j<ny;j++)
       {
          if(i>=nx-1) w[2*(j*nx+i)+0]=0;
          if(j>=ny-1) w[2*(j*nx+i)+1]=0;
       };
      printstate();continue;
    } else
    if(c[0]=='q') {if(!mode)Gxy(2,23);} else {
        if (!mode) { Res();Cls(); }
        if (!mode) Gxy(15,1);
        printf(">>> Monte-Carlo-Methode fuer das Ising-Modell <<<\n");
        if (!mode) Gxy( 1,3);
        printf("Modell: H=Sum Jij Si Sj + B Sum Si\n");
        printf(" i,j Nachbarplaetze,           Jij=+1/-1\n");
        printf(" Si  z-Komponente des Spins i,   S=+1/-1\n");
        printf(" B   aeusseres Feld        M=mittlere Magnetisierung\n");
        printf("Parameter:   <n>=ganze Zahl  <f>=Fliesskommazahl\n");
        printf("zz   - zufaelligen Zustand erzeugen\n");
        printf("z<n> - Zufallsgenerator initiieren\n");
        printf("bz   - zufaellige Bindungen           J=-1^n\n");
        printf("bf   - ferromagnetische Bindungen     J=-1   b4--------\n");
        printf("ba   - antiferromagnetische Bindungen J= 1   b4++++++++\n");
        printf("bp   - frustierte Plaketten                  b4-+++++-+\n");
        printf("b4x  - 4er Plakette                          b4xxxxxxxx\n");
        printf("p    - setze offene Randbedingungen (OBC)\n");
        printf("e<n> - n-Einzelschritte\n");
        printf("m<n> - n-Monte-Carlo-Schritte\n");
        printf("g<n> - Gittergroesse aendern (max. %dx%d)\n",Nx,Ny);
        printf("t<f> - setze Temperatur (k*T)\n");
        printf("f<f> - setze Feld       (B)\n");
        printf("q    - quit\n");Gets(c);
        if((c[0]!='?')&&(c[0]!='q')){Cls();printstate();}
        continue;
    }
  };
  return(0);
}

